=== debian/changelog ===
visp (3.1.0-2) unstable; urgency=medium

  * remove useless patches
  * Introduce new patches to fix issues. Closes: #886140, #886141
  * Update to last version of Debian policy

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Sun, 14 Jan 2018 22:28:11 +0100

visp (3.1.0-1) unstable; urgency=medium

  * Remove 3.0.1 patches
  * New upstream version 3.1.0
  * Update debian material for visp 3.1.0
    Fix debian issues: Closes: #856703, #878937, #871414
  * Add patches for visp 3.1.0
  * Add libvisp-imgproc-dev
  * Fix lintian warnings
  * Remove Coin3D usage since it produces a segfault in mbt examples
    when calling SoDB::Init()

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Thu, 28 Dec 2017 10:31:31 +0100
